#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

void solve() {
    int n;
    cin>>n;
    vector<ll> a(n), b(n), c(n);
    for (int i = 0; i < n;i++) {
        cin>>a[i]>>b[i]>>c[i];
    }
    ll res = 0;
    for (int i = 1; i <= 2 * n; i++) {
        ll cr = 0;
        for (int j = 0; j < n; j++) {
            if (a[j] == i || b[j] == i) {
                cr += c[j];
            }
        }
        res = max(res, cr);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n;j++) {
            if (i == j) {
                continue;
            }
            for (int k = 0; k < n; k++) {
                if (i == k || j == k) {
                    continue;
                }
                unordered_set<int> st;
                vector<int> vc = {i, j, k};
                for (auto& el : vc) {
                    st.insert(a[el]);
                    st.insert(b[el]);
                }
                if (st.size() <= 3) {
                    res = max(res, c[i] + c[j] + c[k]);
                }
            }
        }
    }
    cout << res << endl;
}

int main() {
    // freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin>>t;
    while (t) {
        solve();
        t--;
    }
}
